<?php

namespace App\Http\Controllers;

use App\Models\Baja;
use Illuminate\Http\JsonResponse;
use Illuminate\Http\Request;

class BajaController extends Controller
{
    /**
     * Display a listing of the resource.
     */
    public function index(): JsonResponse
    {
        $items = Baja::all();

        return response()->json([
            'success' => true,
            'data' => $items,
            'message' => 'Registros obtenidos correctamente',
        ], 200);
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(Request $request): JsonResponse
    {
        $payload = $request->only((new Baja())->getFillable());
        $baja = Baja::create($payload);

        return response()->json([
            'success' => true,
            'data' => $baja,
            'message' => 'Registro creado correctamente',
        ], 201);
    }

    /**
     * Display the specified resource.
     */
    public function show(Baja $baja): JsonResponse
    {
        return response()->json([
            'success' => true,
            'data' => $baja,
            'message' => 'Registro obtenido correctamente',
        ], 200);
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(Request $request, Baja $baja): JsonResponse
    {
        $payload = $request->only((new Baja())->getFillable());
        $baja->update($payload);

        return response()->json([
            'success' => true,
            'data' => $baja,
            'message' => 'Registro actualizado correctamente',
        ], 200);
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy(Baja $baja): JsonResponse
    {
        $baja->delete();

        return response()->json([
            'success' => true,
            'message' => 'Registro eliminado correctamente',
        ], 200);
    }
}